<html lang="en">
<head>
<title>Search Optimization - Semantic Manual</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Semantic Manual">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="up" href="Installation_002fBasic-Configuration.html#Installation_002fBasic-Configuration" title="Installation/Basic Configuration">
<link rel="prev" href="Canned-Configuration.html#Canned-Configuration" title="Canned Configuration">
<link rel="next" href="Parsing-Optimization.html#Parsing-Optimization" title="Parsing Optimization">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<!--
This manual documents Semantic, a new intrastructure for parser
based text analysis for Emacs.

Copyright (C) 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2007 Eric M. Ludlam
Copyright (C) 2001, 2002, 2003, 2005 David Ponce
Copyright (C) 2002, 2003 Richard Y. Kim

     Permission is granted to copy, distribute and/or modify this
     document under the terms of the GNU Free Documentation License,
     Version 1.1 or any later version published by the Free Software
     Foundation; with the Invariant Sections being list their titles,
     with the Front-Cover Texts being list, and with the Back-Cover
     Texts being list.  A copy of the license is included in the
     section entitled ``GNU Free Documentation License''.
-->
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Search-Optimization"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Parsing-Optimization.html#Parsing-Optimization">Parsing Optimization</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Canned-Configuration.html#Canned-Configuration">Canned Configuration</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="Installation_002fBasic-Configuration.html#Installation_002fBasic-Configuration">Installation/Basic Configuration</a>
<hr>
</div>

<h3 class="section">2.2 Search Optimization</h3>

<p>A common use of semantic is for smart completion and tag browsing. 
These operations involve searching through the tags of your files. 
For complete documentation on configuring your searches,
<a href="../semantic_002duser/Semanticdb-Search-Configuration.html#g_t_0028semantic_002duser_0029Semanticdb-Search-Configuration">(semantic-user)Semanticdb Search Configuration</a>.

<p>The default configuration is for fast searches that may not find your
symbols all the time.

<p>Searching is controlled with <code>semanticdb-find-default-throttle</code>. 
To force the search to find and read and tag files not yet in memory,
you might add code like this for C mode.

<pre class="example">     (setq-mode-local c-mode
     		 semanticdb-find-default-throttle
     		 '(project unloaded system recursive))
</pre>
<p>Finding unloaded databases requires knowing the search path.  You can
find headers on a system or project level search path. 
See <a href="../semantic_002duser/Include-paths.html#g_t_0028semantic_002duser_0029Include-paths">(semantic-user)Include paths</a>.

<p>If using the above tactic doesn't work for your language (something
other than C/C++), it may be that your language isn't configured
properly for finding include files.  You would need to refer to the
<a href="../semantic_002dlangdev/#g_t_0028semantic_002dlangdev_0029">(semantic-langdev)</a> for details.

<p>If you were to be working on a linux kernel, you might opt to
configure your search path in your <samp><span class="file">.emacs</span></samp> file with code like
this:

<pre class="example">     (semantic-reset-system-include 'c-mode)
     (semantic-add-system-include "/usr/src/linux-2.4/include" 'c-mode)
</pre>
<p>It is also useful to find and install extra search engine back-ends,
such See <a href="../semantic_002duser/Create-System-Databases.html#g_t_0028semantic_002duser_0029Create-System-Databases">(semantic-user)Create System Databases</a>.  Ebrowse is one such back-end for
C and C++ code.

<p>You might create an ebrowse database for your C include files like
this:

<pre class="example">     M-x semanticdb-create-ebrowse-database RET /usr/include/ RET
</pre>
<p>This will create the database, save it, and add it to the database
search list for your C and C++ based projects.  These databases will
be created in your <samp><span class="file">~/.semanticdb</span></samp> directory to be reloaded in
future Emacs sessions.

</body></html>

